
using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:submit_case_record
    /// </summary>
    public partial class submit_case_record
    {
        public submit_case_record()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "submit_case_record");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from submit_case_record");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.submit_case_record model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into submit_case_record(");
            strSql.Append("CASE_SERIAL,AREA_CODE,RECORD_ID,RECORD_PHONE,RECORD_STATUS,RECORD_TYPE,RECORD_STARTTIME,RECORD_ENDTIME,RECORD_LENGTH,RECORD_LOGINID,RECORD_URL,CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@CASE_SERIAL,@AREA_CODE,@RECORD_ID,@RECORD_PHONE,@RECORD_STATUS,@RECORD_TYPE,@RECORD_STARTTIME,@RECORD_ENDTIME,@RECORD_LENGTH,@RECORD_LOGINID,@RECORD_URL,@CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_PHONE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_STATUS", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_TYPE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_STARTTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_ENDTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_LENGTH", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_LOGINID", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_URL", SqlDbType.NVarChar,500),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.RECORD_ID;
            parameters[3].Value = model.RECORD_PHONE;
            parameters[4].Value = model.RECORD_STATUS;
            parameters[5].Value = model.RECORD_TYPE;
            parameters[6].Value = model.RECORD_STARTTIME;
            parameters[7].Value = model.RECORD_ENDTIME;
            parameters[8].Value = model.RECORD_LENGTH;
            parameters[9].Value = model.RECORD_LOGINID;
            parameters[10].Value = model.RECORD_URL;
            parameters[11].Value = model.CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.submit_case_record model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update submit_case_record set ");
            strSql.Append("CASE_SERIAL=@CASE_SERIAL,");
            strSql.Append("AREA_CODE=@AREA_CODE,");
            strSql.Append("RECORD_ID=@RECORD_ID,");
            strSql.Append("RECORD_PHONE=@RECORD_PHONE,");
            strSql.Append("RECORD_STATUS=@RECORD_STATUS,");
            strSql.Append("RECORD_TYPE=@RECORD_TYPE,");
            strSql.Append("RECORD_STARTTIME=@RECORD_STARTTIME,");
            strSql.Append("RECORD_ENDTIME=@RECORD_ENDTIME,");
            strSql.Append("RECORD_LENGTH=@RECORD_LENGTH,");
            strSql.Append("RECORD_LOGINID=@RECORD_LOGINID,");
            strSql.Append("RECORD_URL=@RECORD_URL,");
            strSql.Append("CreateTime=@CreateTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@CASE_SERIAL", SqlDbType.NVarChar,50),
                    new SqlParameter("@AREA_CODE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_ID", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_PHONE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_STATUS", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_TYPE", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_STARTTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_ENDTIME", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_LENGTH", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_LOGINID", SqlDbType.NVarChar,50),
                    new SqlParameter("@RECORD_URL", SqlDbType.NVarChar,500),
                    new SqlParameter("@CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.CASE_SERIAL;
            parameters[1].Value = model.AREA_CODE;
            parameters[2].Value = model.RECORD_ID;
            parameters[3].Value = model.RECORD_PHONE;
            parameters[4].Value = model.RECORD_STATUS;
            parameters[5].Value = model.RECORD_TYPE;
            parameters[6].Value = model.RECORD_STARTTIME;
            parameters[7].Value = model.RECORD_ENDTIME;
            parameters[8].Value = model.RECORD_LENGTH;
            parameters[9].Value = model.RECORD_LOGINID;
            parameters[10].Value = model.RECORD_URL;
            parameters[11].Value = model.CreateTime;
            parameters[12].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_record ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from submit_case_record ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_record GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,CASE_SERIAL,AREA_CODE,RECORD_ID,RECORD_PHONE,RECORD_STATUS,RECORD_TYPE,RECORD_STARTTIME,RECORD_ENDTIME,RECORD_LENGTH,RECORD_LOGINID,RECORD_URL,CreateTime from submit_case_record ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.submit_case_record model = new CallCenterApi.Model.submit_case_record();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.submit_case_record DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.submit_case_record model = new CallCenterApi.Model.submit_case_record();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["CASE_SERIAL"] != null)
                {
                    model.CASE_SERIAL = row["CASE_SERIAL"].ToString();
                }
                if (row["AREA_CODE"] != null)
                {
                    model.AREA_CODE = row["AREA_CODE"].ToString();
                }
                if (row["RECORD_ID"] != null)
                {
                    model.RECORD_ID = row["RECORD_ID"].ToString();
                }
                if (row["RECORD_PHONE"] != null)
                {
                    model.RECORD_PHONE = row["RECORD_PHONE"].ToString();
                }
                if (row["RECORD_STATUS"] != null)
                {
                    model.RECORD_STATUS = row["RECORD_STATUS"].ToString();
                }
                if (row["RECORD_TYPE"] != null)
                {
                    model.RECORD_TYPE = row["RECORD_TYPE"].ToString();
                }
                if (row["RECORD_STARTTIME"] != null)
                {
                    model.RECORD_STARTTIME = row["RECORD_STARTTIME"].ToString();
                }
                if (row["RECORD_ENDTIME"] != null)
                {
                    model.RECORD_ENDTIME = row["RECORD_ENDTIME"].ToString();
                }
                if (row["RECORD_LENGTH"] != null)
                {
                    model.RECORD_LENGTH = row["RECORD_LENGTH"].ToString();
                }
                if (row["RECORD_LOGINID"] != null)
                {
                    model.RECORD_LOGINID = row["RECORD_LOGINID"].ToString();
                }
                if (row["RECORD_URL"] != null)
                {
                    model.RECORD_URL = row["RECORD_URL"].ToString();
                }
                if (row["CreateTime"] != null && row["CreateTime"].ToString() != "")
                {
                    model.CreateTime = DateTime.Parse(row["CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,CASE_SERIAL,AREA_CODE,RECORD_ID,RECORD_PHONE,RECORD_STATUS,RECORD_TYPE,RECORD_STARTTIME,RECORD_ENDTIME,RECORD_LENGTH,RECORD_LOGINID,RECORD_URL,CreateTime ");
            strSql.Append(" FROM submit_case_record ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,CASE_SERIAL,AREA_CODE,RECORD_ID,RECORD_PHONE,RECORD_STATUS,RECORD_TYPE,RECORD_STARTTIME,RECORD_ENDTIME,RECORD_LENGTH,RECORD_LOGINID,RECORD_URL,CreateTime ");
            strSql.Append(" FROM submit_case_record ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM submit_case_record ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from submit_case_record T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "submit_case_record";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}